
/*
 * MGL graphics library
 * Copyright (C) 1999-2000, ing. Marek Gayer

 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.

 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

// ukazkova aplikace
// testovaci programy

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <GL/glut.h>
#include <mgl.h>

//#pragma comment(lib, "opengl32.lib")
//#pragma comment(lib, "winmm.lib")

extern void configInit (void);
extern void configDisplay (void);
extern void configKeyboard (void);

extern void mipmapInit (void);
extern void mipmapDisplay (void);
extern void mipmapKeyboard (void);

extern void testsInit (void);
extern void testsDisplayPrimitives (void);
extern void testsDisplayFilled (void);
extern void testsDisplayTextures (void);
extern void testsDisplaySubTextures (void);
extern void testsDisplayFonts (void);
extern void testsDisplayTexturedRectangles (void);
extern void testsKeyboard (void);

extern void figuresInit (void);
extern void figuresDisplay (void);

extern void firstInit (void);
extern void firstDisplay (void);


mglFont *mainFont;

int fps = 1;
int renderer = 0;
int extensions = 0;
int screen = 0;
int showtime = 1;
int systemtime = 0;
int help = 0;
int functionkeys = 0;
int smallhelp = 1;
int config = 0;
int comments = 0;

int mainPaused;
int mainOption = 0;
int mainSpeed = 5;

//int buttons;
//int state;



extern void showinfo (mglColor color);


extern void setupContext (void);


void mainMakeCheckImage (unsigned char *map, int size, int segs)
{
  int i,j;

  for (j = 0; j < size; j++)
  {
    for (i = 0; i < size; i++)
    {
      if ((i ^ j) & segs)
        *map = 0;
      else
        *map = 255;
      map++;
    }
  }
}


typedef void (*displayType) (void);

typedef struct
{
  int w;
  int h;
  int virtualX;
  int virtualY;
  char *title;
  char *help;
  mglColor *color;
  displayType display;
  displayType init;
  int parammax;
  displayType keyb;
  int option;
//  displayType mouse;
} contextType;

extern contextType context [];
extern int contextMax;

int contextCur;
int contextLast = -1;
int savedcontext;

int defwinw = 800;
int defwinh = 600;

int winw;
int winh;



int saved;


int contextCur;


void showinfo (mglColor color)
{
  char s [4096];
  char s2 [4096];
  int mytime;
  mglColor c;
  int x, y;

  mglSetTextureColors (color);

  mglSetTextureZoom ((float) 0.8 * mglVirtualWidth / 800);

  if (renderer)
  {
    sprintf (s, "OpenGL vendor: %s\n"
                "OpenGL renderer: %s\n"
                "OpenGL version: %s\n", mglVendor, mglRenderer, mglVersion);
    mglFontWrap = mglVirtualWidth / mainFont->w;
    if (extensions)
    {
      sprintf (s2, "OpenGL extensions: %s\n"
                  "Maximum texture size: %i x %i\n", mglExtensions, mglMaxTextureSize, mglMaxTextureSize);
      strcat (s, s2);
      if (_mallocated)
      {
        sprintf (s2, "Memory allocated: %i\n", _mallocated);
        strcat (s, s2);
      }
      sprintf (s2, "Local textures memory: %i\n"
               "Resident textures memory: %i\n", mglLocalTexturesMemory, mglResidentTexturesMemory);
      strcat (s, s2);
    }
    mglFontWordWrap = 1;
    mglPuts (mainFont, s, 0, 0);
    mglFontWordWrap = 0;
  }
  else
  {
    if (config)
      mglPuts (mainFont, "Pro nvrat zpt stisknte klvesu F3", 0, 0);
    else
    {
      if (smallhelp)
      {
        mglPuts (mainFont, "Chcete-li zskat npovdu, stisknte klvesu F1", 0, 0);
      }
    }
  }

  if (fps)
  {
    mglShowFPS (mainFont, mglVirtualWidth /*- 6*(int) (mainFont->w * mglTextureZoomX)*/, 0);
  }

  if (showtime)
  {
    if (systemtime)
      mytime = mglSystemTime;
    else
      mytime = mglTime;
    sprintf (s, "%02i:%02i:%02i", mglHours (mytime), mglMinutes (mytime), mglSecs (mytime));

	x = 8 * mainFont->w * mglTextureZoomX;
	y = mainFont->h * mglTextureZoomY;
    mglPuts (mainFont, s, mglVirtualWidth - x, mglVirtualHeight - y);
  }

  if (screen)
  {
    sprintf (s, "Screen %i x %i / %i bpp", mglScreenWidth, mglScreenHeight, mglBitsPerPixel);
    mglPuts (mainFont, s, 0,
              mglVirtualHeight - 2* (int) (mainFont->h * mglTextureZoomY));
    sprintf (s, "Window %i x %i", mglWindowWidth, mglWindowHeight);
    mglPuts (mainFont, s, 0,
              mglVirtualHeight - (int) (mainFont->h * mglTextureZoomY) );
  }

  if (config)
  {

  }

  if ((help && context [contextCur].help) || functionkeys)
  {
    c = mglBlack;
    c.a = 0.7f;
    mglSetRectangleColors (c);
    mglDrawFilledRectangle (24, 24, mglVirtualWidth - 48, mglVirtualHeight - 48);
    x = 50;
    y = 50;

    mglFontWordWrap = 1;
    mglFontWrap = (mglVirtualWidth  - 100) / (int) (mainFont->w * mglTextureZoomX);

    if (functionkeys)
    {
      mglSetTextureColors (mglWhite);

      mglPuts (mainFont, "\a6K dispozici jsou tyto klvesy\a0\n"
                    "\n"
                    "\a5PgUp\a0       Pejde na dal obrazovku\n"
                    "\a5PgDn\a0       Pejde na pedchoz obrazovku\n"
                    "\a5Home\a0       Pejde na prvn obrazovku\n"
                    "\a5End\a0        Pejde na posledn obrazovku\n"
                    "\a5F1\a0         Zapne/vypne npovdu\n"
                    "\a5F2\a0         Zapne/vypne tento seznam klves\n"
                    "\a5F3\a0         Pepne na test vstupnch zazeni\n"
                    "\a5F4\a0         Obnov aktuln obrazovku\n"
                    "\a5F5\a0         Ulo aktuln obrazovku na disk do obrzku TGA\n"
                    "\a5F9\a0         Zapne/vypne vpis informac o ovladai OpenGL\n"
                    "\a5Shift+F9\a0   Zapne/vypne vpis rozench informac\n"
                    "\a5F10\a0        Zapne/vypne vpis potu rmc za sekundu\n"
                    "\a5F11\a0        Zapne/vypne vpis rozlien obrazovky a okna\n"
                    "\a5F12\a0        Zapne/vypne vpis asu knihovny MGL\n"
                    "\a5Shift+F12\a0  Zapne/vypne vpis systmovho asu\n"
                    "\a5+\a0          Zvt velikost okna\n"
                    "\a5-\a0          Zmen velikost okna\n"
                    "\a5Kurz.ipky\a0 Zmn parametry aktuln obrazovky\n"
                    "\a5Esc\a0        Ukon tuto testovac aplikaci\n"
                    "\n"
                    "\a5Lev tlatko myi\a0       \a2Pejde na dal obrazovku\a0\n"
                    "\a5Prav tlatko myi\a0      \a2Pejde na pedchoz obrazovku\a0\n"
                    "\a5Prostedn tlatko myi\a0 \a2Pepn mezi npovdou\a0\n"
                    , x, y);
    }
    else
    {
      if (help)
      {
        mglSetTextureColors (mglWhite);
        mglPuts (mainFont, context [contextCur].help, x, y);
        mglFontWordWrap = 0;
        mglFontWrap = 0;
      }
    }
  }


  if (mainPaused)
  {
    /*
    c = mglBlack;
    c.a = 0.333;
    mglSetRectangleColors (c);
    mglFilledRectangle (160, 120, 800 - 2*160, 600 - 2 * 120);
    x = 160 +50;
    y = 120 + 50;

    mglSetTextureZoom (1);
    mglSetRectangleColors (mglWhite);


    mglPuts (mainFont, "\n\nPaused\n"
                  "Press \a5F4\a0 to continue\n", x, y);
    */
  }
}


int savedFiles;

void save (void)
{
  char filename [80];
  char s [90];
  mglImage *image;

  mglTestOpenGLError ();

  image = mglGetRGBImage (0, 0, mglWindowWidth, mglWindowHeight);
  savedFiles++;
  sprintf(filename, "saved%03d.tga", savedFiles);
  remove (filename);
  mglSaveImage (filename, image);
  mglDeleteImage (image);
  sprintf (s, "Screen has been saved to %s", filename);
  mglMessage ("Note", s);
}




int plusx;
int plusy;
int minx;
int miny;
int maxx;
int maxy;

void setupContext (void)
{
  contextType *c;

  if (contextLast != -1)
  {
    context [contextLast].option = mainOption;
    if (context [contextLast].w)
      context [contextLast].w = winw;
    else
      defwinw = winw;
    if (context [contextLast].h)
      context [contextLast].h = winh;
    else
      defwinh = winh;
  }

  contextCur = contextCur % (contextMax+2);
  c = &context [contextCur];

  if (contextLast != contextCur)
  {
    mainOption = c->option;
    if (!mainOption)
      mainOption = 1;

    if (defwinw > mglScreenWidth)
      defwinw = mglScreenWidth;

    if (defwinw > mglScreenWidth)
      defwinh = mglScreenHeight;

    if (c->w)
      winw = c->w;
    else
      winw = defwinw;
    if (c->h)
      winh = c->h;
    else
      winh = defwinh;

    contextLast = contextCur;


   if (c->init)
      c->init ();

	mglSetupView (0, c->virtualX, c->virtualY, 0);
    mglSetWindowSize (winw, winh);
    if (c->title)
      mglSetWindowTitle (c->title);
    mglSetMouseCursor (GLUT_CURSOR_INHERIT);


    if (winw == winh)
    {
      minx = miny = 128;
      maxx = maxy = mglScreenHeight;
      plusx = plusy = 16;
    }
    else
    {
      minx = 128; miny = 96;
      maxx = mglScreenWidth; maxy = mglScreenHeight;
      plusx = 32; plusy = 24;
    }

    mglRotationAngle = 0;
  }
  else
  {
    c->display ();

    if (c->color != &mglBlank)
      showinfo (*c->color);
  }
}


void contextPlus (void)
{
  if (contextCur < contextMax)
  {
    contextCur++;
  }
}

void contextMinus (void)
{
  if ((contextCur <= contextMax) && (contextCur > 0))
    contextCur--;
}


void mouseHandler (int event)
{
  switch (event)
  {
    case MGL_LEFT_BUTTON_DOWN:
      contextMinus ();
      break;
    case MGL_RIGHT_BUTTON_DOWN:
      contextPlus ();
      break;
    case MGL_MIDDLE_BUTTON_DOWN:
      if ((help == 0) && (functionkeys == 0))
      {
        smallhelp = 0;
        help = 1;
      }
      else
      if ((help == 1) && (functionkeys == 0))
      {
        functionkeys = 1;
        help = 0;
      }
      else
      if ((help == 0) && (functionkeys == 1))
      {
        functionkeys = 0;
      }
      break;
  }
}


void keyboardHandleFunctionKeys (void)
{
  switch (mglLastKey)
  {
    case MGL_KEY_F10:
      fps = !fps;
      break;
    case MGL_KEY_F11:
      screen = !screen;
      break;
    case MGL_KEY_F9:
      if (mglShift)
        if (renderer && extensions)
          renderer = 0;
        else
          renderer = extensions = 1;
      else
      {
        renderer = !renderer;
        extensions = 0;
      }
      break;
    case MGL_KEY_F5:
      save ();
      break;
    case MGL_KEY_F1:
      help = !help;
      functionkeys = 0;
      smallhelp = 0;
      break;
    case MGL_KEY_F2:
      functionkeys = !functionkeys;
      help = 0;
      break;
    case MGL_KEY_F3:
      if (!config)
      {
        savedcontext = contextCur;
        contextCur = contextMax + 1;
      }
      else
      {
        contextCur = savedcontext;
      }
      config = !config;
      break;
    case MGL_KEY_F4:
      if (!config)
      {
        context [contextLast].option = mainOption;
        contextCur = contextLast;
        contextLast = -1;
      }
      break;
    case MGL_KEY_F12:
      if (mglShift)
        if (showtime && systemtime)
        {
          showtime = 0;
        }
        else
          showtime = systemtime = 1;
      else
      {
        showtime = !showtime;
        systemtime = 0;
      }
      break;
      systemtime = mglShift;
      showtime = !showtime;
      break;
  }
}



void keyboardHandler (int key)
{
  keyboardHandleFunctionKeys ();

  if (context [contextCur].keyb != NULL)
  {
    context [contextCur].keyb ();
  }

  if (key >= '1' && key <= '1'+context [contextCur].parammax)
    mainOption = key - '1';

  switch (key)
  {
    case 27:
      if (help)
        help = 0;
      else
      {
        if (!config)
        {
          exit (0);
        }
      }
      break;
    case MGL_KEY_PAGE_DOWN:
      contextPlus ();
      break;
    case MGL_KEY_PAGE_UP:
      contextMinus ();
      break;
    case '+':
      if (winw < maxx)
        winw += plusx;
      if (winh < maxy)
        winh += plusy;
      mglSetWindowSize (winw, winh);
      break;
    case '-':
      if (winw > minx)
        winw -= plusx;
      if (winh > miny)
        winh -= plusy;
      mglSetWindowSize (winw, winh);
      break;
    case MGL_KEY_LEFT:
      if (mainOption > 1)
        mainOption--;
      break;
    case MGL_KEY_RIGHT:
      if (mainOption < context [contextCur].parammax)
        mainOption++;
      break;
    case MGL_KEY_UP:
      if (mainSpeed < 9)
        mainSpeed++;
      break;
    case MGL_KEY_DOWN:
      if (mainSpeed > 0)
        mainSpeed--;
      break;
    case MGL_KEY_HOME:
      if (!config)
        contextCur = 0;
      break;
    case MGL_KEY_END:
      if (!config)
        contextCur = contextMax;
      break;
    default:
      break;
  }
}

//static char defaultHelp [] = "\n\n\n\nTato obrazovka bude obsahovat npovdu\n"
//                      "\a5F2\a0 Vype seznam klves\n";

//static const mglColor *base [] = {&mglWhite, &mglRed, &mglGreen, &mglBlue, &mglYellow,
//&mglCyan, &mglMagenta, &mglBlack, &mglBlank};

char firstHelp [] = "\a6Vtejte v npovd testovac aplikace MGL !\a0\n"
"\n"
"Tato obrazovka demonstruje zkladn monosti a funkce knihovny \a7MGL\a0."
" Vechny tyto demonstrovan monosti je mon otestovat v nsledujcch obrazovkch.\n"
"\n"
"Klvesou \a5F1\a0 mete kdykoliv zapnout nebo "
"vypnout tuto npovdu k jednotlivm obrazovkm.\n"
"\n"
"Klvesou \a5F2\a0 mete kdykoliv zskat seznam "
"vech klves, ktermi lze ovldat tuto "
"demonstran a testovac aplikaci.\n"
"\n"
"Mezi jednotlivmi obrazovkami tto aplikace je mon se pepnat pomoc "
"klves \a5PgUp\a0 a \a5PgDn\a0, nebo pomoc "
"\a5levho\a0 a \a5pravho tlatka myi\a0.\n"
"\n"
"Zdrojov kd vykreslujc tuto obrazovku volanm funkc "
"knihovny \a7MGL\a0 je "
"v souboru \a3demo/first.c\a0\n"
"\n";

char configHelp [] =
"\a6Test vtupnch zazen knihovny MGL\a0\n"
"\n"
"Tato obrazovka umouje otestovat vstupn "
"zazeni, se ktermi je mon pracovat pomoc modulu \a7Input\a0 "
"knihovny \a7MGL\a0.\n"
"\n"
"V lev asti obrazovky jsou vypisovny stitn "
"klvesy spolen se stavem klves \a5Shift\a0, \a5Ctrl\a0 a \a5Alt\a0. "
"Ve vstupnm poli dole lze zadat etzec znak.\n"
"\n"
"V prav sti obrazovky je testovn aktuln stav tlatek myi a pozice "
" kurzoru myi. Na achovnici dole lze vybrat vzhled kurzoru myi.\n"
"\n"
"Zdrojovy kd vykreslujc tuto obrazovku je "
"v souboru \a3demo/first.c\a0\n"
"\n";

char mipmapHelp [] =
"\a6Princip mipmappingu a filtrovan textur\a0\n"
"\n"
"Tato obrazovka demonstruje princip "
"technologie mipmappingu. Rzn barvy na desce achovnice "
"odpovdaj pouit mipmap rznch rovn.\n"
"\n"
"Dle jsou demonstrovny rzne techniky, ktere pomhaj zlepit kvalitu obrazu"
" pri zmnch velikosti textur.\n"
"\n"
"\a2Deska je postupn vykreslena s aplikac technik:\a0\n"
"\a3*\a0 Bez filtrovn\n"
"\a3*\a0 S bilinernm filtrovnm\n"
"\a3*\a0 S pouitm mipmappingu bez bilinernho filtrovn\n"
"\a3*\a0 S pouitm mipmappingu a s bilinernim filtrovnm \n"
"\a3*\a0 S trilinernm filtrovnm\n"
"\n"
"Pro volbu tchto reim pouijte klvesy "
"\a5lev\a0 a \a5prav ipka\a0.\n"
"\n"
"Zdrojov kd vykreslujic tuto obrazovku kombinovanm volnm "
"funkci knihovny MGL a pmho voln knihovny OpenGL "
"je v souboru \a3demo/mipmap.c\a0\n"
"\n";

char testsHelp [] =
"\a6Test vykreslovn grafickch objekt\a0\n"
"\n"
"Nsledujc obrazovky testuj postupn "
"vechny vykreslovac funkce knihovny \a7MGL\a0.\n"
"\n"
"Zobrazeno je vzdy nkolik objekt urit "
"skupiny, s nhodn zvolenou velikost a barvou. Objekty "
"jsou rotovny kolem sv osy a posunovny.\n"
"\n"
"\a2Na celkem esti obrazovkch jsou postupn otestovny:\a0\n"
"\a3*\a0 Body, seky, trojhelnky a tverce\n"
"\a3*\a0 Vyplnn trojhelnky a tverce\n"
"\a3*\a0 Obrazov mapy implementovan pomoc textur\n"
"\a3*\a0 Vezy z textur\n"
"\a3*\a0 Texturovan obdelnky\n"
"\a3*\a0 Znakov etzce vykreslen testovacm fontem\n"
"\n"
"Pro testy jsou nateny vechny formty a typy obrazovch map podporovan modulem "
"\a7Images\a0 knihovny \a7MGL\a0.\n"
"\n"
"Vykreslovn je otestovno vdy s volitelnou "
"barevnou interpolac a prhlednmi vrstvami. "
"Tyto parametry je mon zmnit klvesami "
"\a5lev\a0 a \a5prav ipka.\a0 Rychlost pohybu lze zmnit "
"klvesami \a5horn\a0 a \a5doln ipka\a0\n"
"\n"
"Zdrojov kd vykreslujc tyto obrazovky je "
"v souboru \a3demo/tests.c\a0\n"
"\n";

char figuresHelp [] =
"\a6Ukazkov obrzky pro diplomovou prci\a0\n"
"\n"
"Posledn obrazovka vykresluje obrzky, kter byly "
"vytvoeny pro demonstraci nkterch grafickch "
"technik popsanch v diplomov prci\n"
"\n"
"\a2Obrzky ilustruj tyto principy:\a0\n"
"\a3*\a0 Mapovn textur (texture mapping)\n"
"\a3*\a0 Vyhlazovn hran (antialiasing)\n"
"\a3*\a0 Mchn Prhlednch vrstev (alpha blending)\n"
"\a3*\a0 Interpolace barev (color interpolation)\n"
"\a3*\a0 Zmna velikosti textury bez bilinern interpolace\n"
"\a3*\a0 Zmna velikosti textury s bilinern interpolac\n"
"\a3*\a0 Zpracovn vce textur v jednom prchodu\n  (multitexturing)\n"
"\a3*\a0 Pam ablony (stencil) - ve tyech obrzcch\n"
"\a3*\a0 Tisk font bez zapnutch prhlednch vrstev\n"
"\a3*\a0 Tisk font se zapnutmi prhlednmi vrstvami\n"
"\n"
"Mezi jednotlivmi obrzky se lze pohybovat "
"pomoc klves \a5lev\a0 a \a5prav ipka\a0\n"
"\n"
"Zdrojov kd vykreslujc tyto obrazovky pmm volnm funkc knihovny \a7MGL\a0 "
"je v souboru \a3demo/figures.c\a0\n"
"\n";

contextType context [] = {
  {0, 0, 800, 600, "Demonstrace knihovny MGL - Prehled zkladnch moznost knihovny", firstHelp, &mglRed, firstDisplay, firstInit},
  {0, 0, 800, 600, NULL, testsHelp, &mglBlue, testsDisplayPrimitives, testsInit, 4},
  {0, 0, 800, 600, NULL, testsHelp, &mglBlue, testsDisplayFilled, testsInit, 4},
  {0, 0, 800, 600, NULL, testsHelp, &mglBlue, testsDisplayTextures, testsInit, 4, testsKeyboard},
  {0, 0, 800, 600, NULL, testsHelp, &mglBlue, testsDisplaySubTextures, testsInit, 4, testsKeyboard},
  {0, 0, 800, 600, NULL, testsHelp, &mglBlue, testsDisplayTexturedRectangles, testsInit, 4, testsKeyboard},
  {0, 0, 800, 600, NULL, testsHelp, &mglBlue, testsDisplayFonts, testsInit, 4, testsKeyboard},
  {0, 0, 800, 600, NULL, mipmapHelp, &mglBlue, mipmapDisplay, mipmapInit, 7},
  {640, 640, 1000, 1000, NULL, figuresHelp, &mglBlack, figuresDisplay, figuresInit, 13},
  /******************/
  {0, 0, 800, 600, "Demonstrace knihovny MGL - Test vstupnch zarzen", configHelp, &mglYellow, configDisplay, configInit, 0, configKeyboard}
};

int contextMax = (sizeof (context) / sizeof (contextType) - 1 - 1) ;


int main (int argc, char *argv [])
{
  mglNote ("Initializing MGL test and demonstration application.\n");

  switch (argc)
  {
    case 1:
      break;
    case 3:
      sscanf (argv [1], "%i", &defwinw);
      sscanf (argv [2], "%i", &defwinh);
      if (!defwinw || !defwinh)
      {
        mglMessage ("Error", "Requested screen size is invalid.");
        exit (0);
      }
      break;
    default:
      mglMessage ("Error", "Syntax is: DEMO [<screen_width> <screen_height>]");
      exit (1);
  }

  mglOpenWindow ("Wait ...", 100, 100, defwinw, defwinh);
  setupContext ();

  mainFont = mglLoadFont ("../data/fonts/default.txt", "../data/fonts/default.tga");

  mglSetKeyboardHandler (keyboardHandler);
  mglSetMouseHandler (mouseHandler);
  mglSetDisplayHandler (setupContext);
//  mglSetIdleHandler (idle);

  mglRun ();

  return 0;
}
